from colorama import init, Fore, Back, Style

class Error(Exception): pass

class Expando(object):

    def __init__(self, **kwargs):
        for key in kwargs:
            setattr(self, key, kwargs[key])
            

class Record(dict):
    
    def __init__(self, *args, **kwargs):
        dict.__init__(self, *args, **kwargs)
    
    def __getattr__(self, name):
        if name in self:
            return self[name]
        else:
            raise AttributeError

    def __str__(self):
        items = ['\t%s: %s' % (item, str(self[item])) for item in self]
        return '<Record\n' + '\n'.join(items) + '\n>'
            
        

class Console(object):

    def __init__(self):
        init()
    
    def header(self, text):
        print Fore.WHITE + Style.BRIGHT + '*** ' + text + Fore.RESET + Style.RESET_ALL
        
    def info(self, text):
        print Fore.BLUE + Style.BRIGHT + text + Fore.RESET + Style.RESET_ALL
        
    def warn(self, text):
        print Fore.YELLOW + Style.BRIGHT + 'Warning: ' + text + Fore.RESET + Style.RESET_ALL
        
    def error(self, text):
        print Fore.RED + Style.BRIGHT + 'Error: ' + text + Fore.RESET + Style.RESET_ALL
        
    def log_command(self, text):
        print Fore.GREEN + Style.BRIGHT + 'sh: ' + text + Fore.RESET + Style.RESET_ALL
    
    def debug(self, text):
        print Fore.YELLOW + 'Debug: ' + text + Fore.RESET
        
console = Console()
