from api.fs import FileStore
import unittest2 as unittest
import os

class TestFs(unittest.TestCase):

    def setUp(self):
        os.system('mkdir -p /tmp/splverifiertest')
        
    def tearDown(self):
        os.system('rm -Rf /tmp/splverifiertest')

    def test_smoketest(self):
        FileStore()
        
    def test_init(self):
        fs = FileStore('/tmp')
        self.assertEquals('/tmp', fs.base[0])
    
    def test_get(self):
        fs = FileStore('/tmp')
        self.assertEquals('/tmp', fs.get())
        self.assertEquals('/tmp/xyz', fs.get('xyz'))
    
    def test_create(self):
        fs = FileStore('/tmp', 'splverifiertest/fstest/create')
        fs.create()
        self.assertTrue(os.path.isdir('/tmp/splverifiertest/fstest/create'))
        
    def test_clear(self):
        os.system('mkdir -p /tmp/splverifiertest/fstest/delete')
        fs = FileStore('/tmp', 'splverifiertest/fstest/delete')
        fs.clear()
        self.assertFalse(os.path.isdir('/tmp/splverifiertest/fstest/delete'))

