from splverifier.integration.featurescene import *

ENCRYPT_AUTORESPONDER = dict(
    fix = Scenario(
        'bobKeyAdd',
        'rjhSetAutoRespond',
        'bobToRjh',
    ),
    safe = Scenario(
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhSetAutoRespond',
        ),
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhSetAutoRespond',
            'bobToRjh',
        ),
    ),
)

SIGN_FORWARD = dict(
    fix = Scenario(
        'rjhDeletePrivateKey',
        'bobKeyAdd',
        'chuckKeyAddRjh',
        'rjhEnableForwarding',
        'bobToRjh',
    ),
    safe = Scenario(
        'rjhKeyAdd',
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'rjhDeletePrivateKey',
            'rjhEnableForwarding',
        ),
        'bobKeyAdd',
        'chuckKeyAddRjh',        
        'bobToRjh',        
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'rjhDeletePrivateKey',
            'rjhEnableForwarding',        
            'bobKeyAdd',
        ),
        'chuckKeyAddRjh',        
        'bobToRjh',        
    ),    
)

DECRYPT_AUTORESPONDER = dict(
    fix = Scenario(
        'bobKeyAdd',
        'rjhKeyChange',
        'rjhSetAutoRespond',
        'bobToRjh',        
    ),
    safe = Scenario(
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
        ),
        'rjhSetAutoRespond',
        'bobToRjh',        
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'rjhSetAutoRespond',
        ),        
        'bobToRjh',        
    ),
)

VERIFY_FORWARD = dict(
    fix = Scenario(
        'rjhKeyAdd',
        'rjhEnableForwarding',
        'bobToRjh',
    ),
    safe = Scenario(
        'rjhKeyAdd',
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'rjhEnableForwarding',
        ),
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'rjhEnableForwarding',        
            'bobToRjh',
        ),
    ),
)

DECRYPT_FORWARD = dict(
    fix = Scenario(
        'bobKeyAdd',
        'rjhKeyChange',
        'rjhEnableForwarding',
        'bobToRjh',
    ),
    safe = Scenario(
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
        ),
        'rjhKeyChange',
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'rjhKeyChange',
        ),        
        'bobToRjh',
    ),
    varopt4 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'rjhKeyChange',
            'bobToRjh',
        ),        
    ),
)

ADDRESSBOOK_ENCRYPT = dict(
    fix = Scenario(
        'bobKeyAdd',
        'bobSetAddressBook',
        'bobToRjh',
    ),
    safe = Scenario(
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobSetAddressBook',
        ),
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobSetAddressBook',
            'bobToRjh',
        ),        
    ),
)

ENCRYPT_DECRYPT = dict(
    fix = Scenario(
        'bobKeyAdd',
        'rjhKeyChange',
        'bobToRjh',
    ),
    safe = Scenario(
        
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',        
        ),
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
        ),
    ),
    varopt4 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
        ),
    ),
    varopt5 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
        ),
    ),
    varopt6 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),
    varopt3_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
        ),
    ),
    varopt4_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
        ),
    ),
    varopt5_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),
)

SIGN_VERIFY = dict(
    fix = Scenario(
        'rjhKeyAdd',
        'bobKeyChange',
        'bobToRjh',
    ),
    fix_b = Scenario(
        'rjhKeyAdd',
        'bobKeyChange',
        'bobToRjh',
    ),
    safe = Scenario(
        'rjhKeyAdd',
        'bobToRjh',
    ),
    varopt2 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'bobKeyChange',        
        ),
        'bobToRjh',
    ),
    b_varopt2 = Scenario(
        'rjhKeyAdd',
        SubsetPermutation(            
            'bobKeyChange',
            'bobToRjh',
        ),
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'bobKeyChange',
            'bobToRjh',
        ),
    ),
    b_varopt3 = Scenario(
        'rjhKeyAdd',
        SubsetPermutation(            
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
        ),
    ),
    varopt4 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
        ),
    ),
    b_varopt4 = Scenario(
        'rjhKeyAdd',
        SubsetPermutation(            
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
            'chuckKeyAdd',
        ),
    ),
    a_varopt5 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
            'chuckKeyAdd',
        ),
    ),
    b_varopt5 = Scenario(
        'rjhKeyAdd',
        SubsetPermutation(            
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
            'chuckKeyAdd',
            'rjhKeyChange',
        ),
    ),    
    a_varopt6 = Scenario(
        SubsetPermutation(
            'rjhKeyAdd',
            'bobKeyChange',
            'bobToRjh',
            'bobKeyAdd', 
            'chuckKeyAdd',
            'rjhKeyChange',
        ),
    ),
    varopt2_safe = Scenario(
        'rjhKeyAdd',
        SubsetPermutation(            
            'bobToRjh',
            'rjhKeyChange',
        ),
    ),
    varopt4_safe = Scenario(
       'rjhKeyAdd',
        SubsetPermutation(
            'bobToRjh',
            'rjhKeyChange',
            'chuckKeyAdd',
        ),
    ),
    varopt5_safe = Scenario(
       'rjhKeyAdd',
        SubsetPermutation(
            'bobToRjh',
            'rjhKeyChange',
            'chuckKeyAdd',
            'bobKeyAdd',
        ),
    ),
)

ENCRYPT_VERIFY = dict(
    fix = Scenario(
        'bobKeyAdd',        
        'rjhKeyChange',
        'bobToRjh',
    ),
    safe = Scenario(
        'bobKeyAdd',
        'rjhKeyAdd',
        'bobToRjh',
    ),
    fix_safe2 = Scenario(
        'bobToRjh',
    ),    
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',        
        ),
        'bobToRjh',
    ),
    b_varopt2 = Scenario(
        'bobKeyAdd',
        SubsetPermutation(            
            'rjhKeyChange',
            'bobToRjh',
        ),
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
        ),
    ),
    b_varopt3 = Scenario(
        'bobKeyAdd',
        SubsetPermutation(            
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
        ),
    ),
    varopt4 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
        ),
    ),
    b_varopt4 = Scenario(
        'bobKeyAdd',
        SubsetPermutation(            
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
            'chuckKeyAdd',
        ),
    ),
    a_varopt5 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
            'chuckKeyAdd',
        ),
    ),
    b_varopt5 = Scenario(
        'bobKeyAdd',
        SubsetPermutation(            
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),    
    a_varopt6 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhKeyChange',
            'bobToRjh',
            'rjhKeyAdd', 
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),
    varopt2_safe = Scenario(
        'bobKeyAdd',
        SubsetPermutation(            
            'bobToRjh',
            'bobKeyChange',
        ),
    ),
    varopt4_safe = Scenario(
       'bobKeyAdd',
        SubsetPermutation(
            'bobToRjh',
            'bobKeyChange',
            'chuckKeyAdd',
        ),
    ),
    varopt5_safe = Scenario(
       'bobKeyAdd',
        SubsetPermutation(
            'bobToRjh',
            'bobKeyChange',
            'chuckKeyAdd',
            'rjhKeyAdd',
        ),
    ),
)

ENCRYPT_FORWARD = dict(
    fix = Scenario(
        'bobKeyAdd',
        'rjhEnableForwarding',
        'bobToRjh',
    ),
    safe = Scenario(
        'bobKeyAdd',
        'bobToRjh',
    ),
    #fix_safe2 = Scenario(
    #    'bobKeyAdd',
    #    'rjhEnableForwarding',
    #    ''
    #    'bobToRjh',
    #),    
    varopt2 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',        
        ),
        'bobToRjh',
    ),
    varopt3 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'bobToRjh',
        ),
    ),
    varopt4 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'bobToRjh',
            'rjhKeyAdd', 
        ),
    ),
    varopt5 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
        ),
    ),
    varopt6 = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'rjhEnableForwarding',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),
    varopt3_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
        ),
    ),
    varopt4_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
        ),
    ),
    varopt5_safe = Scenario(
        SubsetPermutation(
            'bobKeyAdd',
            'bobToRjh',
            'rjhKeyAdd',
            'chuckKeyAdd',
            'bobKeyChange',
        ),
    ),
)
